#ifndef RL_VK36N16I_h
#define RL_VK36N16I_h

#include <Arduino.h>
#include <Wire.h>

#if ARDUINO >= 100
#include "Arduino.h"
#else
#include "WProgram.h"
#endif

#define VK36N16I_ADD 0X65

#define Key_1  0
#define Key_4  1
#define Key_7  2
#define Key_x  3
#define Key_2  4
#define Key_5  5
#define Key_8  6
#define Key_0  7
#define Key_3  8
#define Key_6  9
#define Key_9  10
#define Key_j  11
#define Key_A  12
#define Key_B  13
#define Key_C  14
#define Key_D  15


class VK36N16I_TOUCH
{
  public:

   VK36N16I_TOUCH(uint8_t address = VK36N16I_ADD);

   bool begin();

    struct TouchInput {
      uint8_t key_0;
      uint8_t key_1;
      uint8_t key_2;
      uint8_t key_3;
      uint8_t key_4;
      uint8_t key_5;
      uint8_t key_6;
      uint8_t key_7;
      uint8_t key_8;
      uint8_t key_9;
      uint8_t key_A;
      uint8_t key_B;
      uint8_t key_C;
      uint8_t key_D;
      uint8_t key_j;
      uint8_t key_x;
    } touchinput;

    TouchInput touchReadAll(void);

    uint8_t touchRead(uint8_t key);

  private:
  
   uint8_t          _address;

};



#endif
